;
; ჌xL[
;
.include "key.h"

.area _DATA

KEYREPEAT_START_WAIT=150
KEYREPEAT_WAIT=18

; L[̏
keytable::
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
shiftkey::
	.db 0

; L[[h
keymode::
	.db KEYMODE_AUTOREPEAT_MASK + KEYMODE_CAPS_MASK

;
; L[
;
; 
; Ȃ
;
; o
; A:j
;
init_key::
	ld A, #KEYMODE_AUTOREPEAT_MASK + KEYMODE_CAPS_MASK
	ld (#keymode), A
	call key_press_caps
	call key_press_caps
	call key_press_2ndf
	jp key_press_2ndf

;
; L[ԂXV
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
update_key::
	ld HL, #keytable
	
	; OFF ` ) Ă邩?
	ld E, #0x10	; L[l|[g
	ld B, #0x01	; L[Xg[u o͂l
	ld C, #0x11	; L[Xg[u|[g
	ld A, (#ko)
	inc A
update_key_loop:
	dec A
	jr Z, update_keytable
	inc HL
	rlc B
	jr NC, update_key_loop
	
	; nPr ` MDF Ă邩?
	ld C, #0x12
	dec A
	jr Z, update_keytable
	inc HL
	rlc B
	
	; 2ndF ` CLS Ă邩?
	dec A
	jr Z, update_keytable
	inc HL
	
	; break Ă邩?
	dec A
	jr Z, update_keytable_break
	inc HL
	
	; shift Ă邩?
	ld E, #0x13
	ld B, #0x08
	ld C, #0x11

;
; L[e[uXV
;
update_keytable:
	; L[Xg[u
	ld A, B
	out (C), A
	; L[Ԃς?
	push BC
	ld C, E
	in A, (C)
	cp (HL)
	call NZ, key_change
	pop BC
	; L[Xg[u
	xor A
	out (C), A
next_ko:
	; KOύX
	ld HL, #ko
	inc (HL)
	ld A, (HL)
	cp #13
	ret NZ
	xor A
	ld (HL), A
	ret

;
; L[e[uXV(breakL[)
;
update_keytable_break:
	in A, (#0x1f)
	rlca
	and #0x01
	cp (HL)
	call NZ, key_change
	jr next_ko

;
; L[Ԃς
;
key_change:
	; L[ꂽ?
	ld (HL), A
	or A
	jr Z, key_release
	; ǂ̃L[Ă邩?
	ld C, #1
	ld B, C
key_change_loop:
	cp B
	jr Z, key_press
	inc C
	rlc B
	jr NC, key_change_loop
	; 
	ld A, #KEY_DOUBLE
	ld (#lastkey), A
	ret
	
;
; L[ꂽ
;
key_press:
	; A := (keytable - HL) * 8 + C
	push BC
	ld BC, #keytable
	or A
	sbc HL, BC
	sla L
	sla L
	sla L
	ld H, #0
	pop BC
	ld B, #0
	add HL, BC
	ld A, L
	; shift?
	cp #KEY_SHIFT
	ret Z
	; Ji?
	cp #KEY_KANA
	ret Z
	; Caps?
	cp #KEY_CAPS
	jr Z, key_press_caps
	; 2ndF?
	cp #KEY_2NDF
	jr Z, key_press_2ndf
	; L[ݒ肷
	ld (#lastkey), A
	ret
key_press_caps:
	ld A, (#keymode)
	xor #KEYMODE_CAPS_MASK
	ld (#keymode), A
	push AF
	push BC
	rlca
	rlca
	and #0x04
	ld B, #0x03
	ld C, A
	call putstat
	pop BC
	pop AF
	ret
key_press_2ndf:
	ld A, (#keymode)
	xor #KEYMODE_2NDF_MASK
	ld (#keymode), A
	push AF
	push BC
	rrca
	rrca
	rrca
	rrca
	and #0x20
	ld B, #0x02
	ld C, A
	call putstat
	pop BC
	pop AF
	ret

;
; L[ꂽ
;
key_release:
	xor A
	ld (#lastkey), A
	ret

;
; ĂL[̃R[h𓾂
;
; 
; Ȃ
;
; o
; A:L[R[h
; Cy:0.L[ĂȂ 1.Ă
; BC,HL:j
;
getkey::
	ld HL, #repeat_start_counter

	; L[Ԃ𓾂EXV
	ld A, (#oldkey)
	ld B, A
	ld A, (#lastkey)
	ld (#oldkey), A
	
	; L[Ă
	or A
	jr Z, reset_repeat_start_counter
	
	; L[Ă
	cp #0x52
	or A
	jr Z, reset_repeat_start_counter
	
	; ʂ̃L[ꂽ
	cp B
	scf
	jr NZ, reset_repeat_start_counter
	
	; L[s[gJnEFCg
	or A
	dec (HL)
	ret NZ
	inc (HL)

	; L[s[gEFCg
	ld HL, #repeat_counter
	dec (HL)
	ret NZ
	ld (HL), #KEYREPEAT_WAIT

	; I[gs[g?
	or A
	ld HL, #keymode
	bit KEYMODE_AUTOREPEAT_BIT, (HL)
	ret Z

	; L[ꂽ
	scf
	ret

; L[s[gJE^
reset_repeat_start_counter:
	ld (HL), #KEYREPEAT_START_WAIT
	ld HL, #repeat_counter
	ld (HL), #KEYREPEAT_WAIT
	ret

; KO
ko:
	.db 0

; ŌɉꂽL[
lastkey:
	.db 0

; ȑOĂL[
oldkey:
	.db 0

; L[s[gJnJE^
repeat_start_counter:
	.db 0

; L[s[gJE^
repeat_counter:
	.db 0

;
; Copyright 2007 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;

; eof
